SystemOrganization addCategory: #'Spec-BuildUIWithSpec'!
SystemOrganization addCategory: #'Spec-BuildUIWithSpec-Manifest'!

PackageManifest subclass: #ManifestSpecBuildUIWithSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-BuildUIWithSpec-Manifest'!

!ManifestSpecBuildUIWithSpec commentStamp: '<historical>' prior: 0!
I store metadata for this package. These meta data are used by other tools such as the SmalllintManifestChecker and the critics Browser!

!ManifestSpecBuildUIWithSpec class methodsFor: 'code-critics' stamp: 'allezschema 12/17/2018 23:31'!
ruleRBSentNotImplementedRuleV1FalsePositive
	^ #(#(#(#RGClassDefinition #(#ProtocolViewer)) #'2018-12-17T23:31:09.705251+01:00') )! !

ComposablePresenter subclass: #CustomerSatisfaction
	instanceVariableNames: 'buttonHappy buttonNeutral buttonBad sreen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-BuildUIWithSpec'!

!CustomerSatisfaction class methodsFor: 'specs' stamp: 'allezschema 12/17/2018 22:01'!
defaultSpec

	^ SpecLayout composed 
	newColumn: [ :column| 
		column 
		newRow: [ :row| row add: #buttonHappy; add: #buttonNeutral; 
			add: #buttonBad]
		origin:0@0 corner:1@0.7;
		newRow:[:row|row add: #sreen]
		origin:0@0.7 corner:1@1;
		yourself 
		]! !

!CustomerSatisfaction methodsFor: 'accessing' stamp: 'allezschema 12/15/2018 12:17'!
buttonBad
	^ buttonBad! !

!CustomerSatisfaction methodsFor: 'accessing' stamp: 'allezschema 12/15/2018 12:17'!
buttonBad: anObject
	buttonBad := anObject! !

!CustomerSatisfaction methodsFor: 'accessing' stamp: 'Anonymous 12/15/2018 12:17'!
buttonHappy
	^ buttonHappy! !

!CustomerSatisfaction methodsFor: 'accessing' stamp: 'allezschema 12/15/2018 12:17'!
buttonHappy: anObject
	buttonHappy := anObject! !

!CustomerSatisfaction methodsFor: 'accessing' stamp: 'allezschema 12/15/2018 12:17'!
buttonNeutral
	^ buttonNeutral! !

!CustomerSatisfaction methodsFor: 'accessing' stamp: 'allezschema 12/15/2018 12:17'!
buttonNeutral: anObject
	buttonNeutral := anObject! !

!CustomerSatisfaction methodsFor: 'initialization' stamp: 'allezschema 12/17/2018 18:50'!
initializePresenter 
buttonHappy action:[sreen label:buttonHappy label].
buttonNeutral  action:[sreen label:buttonNeutral label].
buttonBad action:[sreen label:buttonBad label].! !

!CustomerSatisfaction methodsFor: 'initialization' stamp: 'allezschema 12/17/2018 23:09'!
initializeWidgets
buttonBad:=self newButton.
buttonHappy :=self newButton .
buttonNeutral :=self newButton .
sreen :=self newLabel .

buttonBad label: 'Bad';
icon: (self iconNamed: #thumbsDown).

buttonHappy label:'Happy';
icon:(self iconNamed: #thumbsUp).

buttonNeutral label:'Neutral';
icon:(self iconNamed: #user).
self focusOrder
add: buttonHappy ;
add:buttonNeutral ;
add:buttonBad .! !

!CustomerSatisfaction methodsFor: 'accessing' stamp: 'allezschema 12/15/2018 12:17'!
sreen
	^ sreen! !

!CustomerSatisfaction methodsFor: 'accessing' stamp: 'allezschema 12/15/2018 12:17'!
sreen: anObject
	sreen := anObject! !

ComposablePresenter subclass: #ProtocolMethodList
	instanceVariableNames: 'label methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-BuildUIWithSpec'!

!ProtocolMethodList class methodsFor: 'specs' stamp: 'allezschema 12/17/2018 23:08'!
defaultSpec

	^ SpecColumnLayout composed 

		add: #label height:self toolbarHeight ;
	add:#methods;
	yourself .
		 
	! !

!ProtocolMethodList methodsFor: 'initialization' stamp: 'allezschema 12/17/2018 22:59'!
initializeWidgets
methods:=self newList .
methods displayBlock: [ :m|m selector ].
label:=self newLabel .
label label: 'Protocol'.
self focusOrder add: methods .! !

!ProtocolMethodList methodsFor: 'api' stamp: 'allezschema 12/17/2018 23:13'!
items:aCollection
methods items: aCollection .! !

!ProtocolMethodList methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:07'!
label
	^ label! !

!ProtocolMethodList methodsFor: 'api' stamp: 'allezschema 12/17/2018 23:13'!
label: aText
label label:aText.! !

!ProtocolMethodList methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:07'!
methods
	^ methods! !

!ProtocolMethodList methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:07'!
methods: anObject
	methods := anObject! !

!ProtocolMethodList methodsFor: 'api' stamp: 'allezschema 12/17/2018 23:14'!
resetSelection 
methods resetSelection ! !

!ProtocolMethodList methodsFor: 'initialization' stamp: 'allezschema 12/17/2018 23:00'!
title 
^'Protocol widget'.! !

!ProtocolMethodList methodsFor: 'api' stamp: 'allezschema 12/17/2018 23:15'!
whenSelectedItemChanged: aBlock
methods whenSelectedItemChanged: aBlock .! !

ComposablePresenter subclass: #ProtocolViewer
	instanceVariableNames: 'models api events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-BuildUIWithSpec'!

!ProtocolViewer class methodsFor: 'specs' stamp: 'allezschema 12/17/2018 23:41'!
defaultSpec
^SpecColumnLayout composed 
add:#models; add:#api; add:#events;
yourself ! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:42'!
api
	^ api! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:42'!
api: anObject
	api := anObject! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:42'!
events
	^ events! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:42'!
events: anObject
	events := anObject! !

!ProtocolViewer methodsFor: 'initialization' stamp: 'allezschema 12/18/2018 00:15'!
initializePresenter 
models whenSelectedItemChanged: [ :aClass|
	api  resetSelection .
	events resetSelection .
	aClass
	ifNil: [ api items: #().events items: #() ]
	ifNotNil: [ 
		api items: (self methodIn:aClass for: 'api').
		events items: (self methodIn:aClass for: 'api-events') ]
	 ].
api whenSelectedItemChanged: [ :method|
	method ifNotNil: [events resetSelection ]].
events whenSelectedItemChanged: [ :method|
	method ifNotNil: [events resetSelection ]].! !

!ProtocolViewer methodsFor: 'initialization' stamp: 'allezschema 12/17/2018 23:22'!
initializeWidgets
models :=self instantiate: WidgetClassList .
api:=self instantiate: ProtocolMethodList .
events:=self instantiate: ProtocolMethodList .

api label: 'api'.
events label: 'api-events'.
self focusOrder add: models ;add:api;add:events.! !

!ProtocolViewer methodsFor: 'api' stamp: 'allezschema 12/17/2018 23:38'!
methodIn:aClass for:protocol
^(aClass methodsInProtocol: protocol) sorted: [:a :b |a selector <b selector ].! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:42'!
models
	^ models! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:42'!
models: anObject
	models := anObject! !

!ProtocolViewer methodsFor: 'initialization' stamp: 'allezschema 12/17/2018 23:23'!
title 
^'Protocol viewer'.! !

!ProtocolViewer methodsFor: 'api' stamp: 'allezschema 12/18/2018 00:23'!
whenAPIChanged:aBlock
api whenSelectedItemChanged: aBlock .! !

!ProtocolViewer methodsFor: 'api' stamp: 'allezschema 12/18/2018 00:22'!
whenClassChanged:aBlock
models whenSelectedItemChanged: aBlock .! !

!ProtocolViewer methodsFor: 'api' stamp: 'allezschema 12/18/2018 00:23'!
whenEventChanged:aBlock
events whenSelectedItemChanged: aBlock .! !

ComposablePresenter subclass: #WidgetClassList
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-BuildUIWithSpec'!

!WidgetClassList class methodsFor: 'specs' stamp: 'allezschema 12/17/2018 22:32'!
defaultSpec

	^ SpecLayout composed 
	add:#list;
	yourself .! !

!WidgetClassList methodsFor: 'initialization' stamp: 'allezschema 12/17/2018 22:30'!
initializeWidgets
	
	list:=self newList .
	list items: (AbstractWidgetPresenter allSubclasses 
		sorted: [:a :b| a name <b name]).
	self  focusOrder add: list.! !

!WidgetClassList methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:07'!
list
	^ list! !

!WidgetClassList methodsFor: 'accessing' stamp: 'allezschema 12/17/2018 23:07'!
list: anObject
	list := anObject! !

!WidgetClassList methodsFor: 'initialization' stamp: 'allezschema 12/17/2018 22:31'!
title 
^'Widgets'.! !

!WidgetClassList methodsFor: 'api' stamp: 'allezschema 12/17/2018 22:35'!
whenSelectedItemChanged: aBlock
list whenSelectDialogChanged: aBlock .! !
